Merge commit 'b963f021b603509b5159873de4919dec441d0782'
[ffmpeg.git] / tests / fate-run.sh
1 #! /bin/sh
2
3 export LC_ALL=C
4
5 base=$(dirname $0)
6 . "${base}/md5.sh"
7
8 base64=tests/base64
9
10 test="${1#fate-}"
11 samples=$2
12 target_exec=$3
13 target_path=$4
14 command=$5
15 cmp=${6:-diff}
16 ref=${7:-"${base}/ref/fate/${test}"}
17 fuzz=${8:-1}
18 threads=${9:-1}
19 thread_type=${10:-frame+slice}
20 cpuflags=${11:-all}
21 cmp_shift=${12:-0}
22 cmp_target=${13:-0}
23 size_tolerance=${14:-0}
24 cmp_unit=${15:-2}
25 gen=${16:-no}
26
27 outdir="tests/data/fate"
28 outfile="${outdir}/${test}"
29 errfile="${outdir}/${test}.err"
30 cmpfile="${outdir}/${test}.diff"
31 repfile="${outdir}/${test}.rep"
32
33 target_path(){
34     test ${1} = ${1#/} && p=${target_path}/
35     echo ${p}${1}
36 }
37
38 # $1=value1, $2=value2, $3=threshold
39 # prints 0 if absolute difference between value1 and value2 is <= threshold
40 compare(){
41     echo "scale=2; v = $1 - $2; if (v < 0) v = -v; if (v > $3) r = 1; r" | bc
42 }
43
44 do_tiny_psnr(){
45     psnr=$(tests/tiny_psnr "$1" "$2" $cmp_unit $cmp_shift 0)
46     val=$(expr "$psnr" : ".*$3: *\([0-9.]*\)")
47     size1=$(expr "$psnr" : '.*bytes: *\([0-9]*\)')
48     size2=$(expr "$psnr" : '.*bytes:[ 0-9]*/ *\([0-9]*\)')
49     val_cmp=$(compare $val $cmp_target $fuzz)
50     size_cmp=$(compare $size1 $size2 $size_tolerance)
51     if [ "$val_cmp" != 0 ] || [ "$size_cmp" != 0 ]; then
52         echo "$psnr"
53         return 1
54     fi
55 }
56
57 oneoff(){
58     do_tiny_psnr "$1" "$2" MAXDIFF
59 }
60
61 stddev(){
62     do_tiny_psnr "$1" "$2" stddev
63 }
64
65 oneline(){
66     printf '%s\n' "$1" | diff -u -b - "$2"
67 }
68
69 run(){
70     test "${V:-0}" -gt 0 && echo "$target_exec" $target_path/"$@" >&3
71     $target_exec $target_path/"$@"
72 }
73
74 probefmt(){
75     run ffprobe -show_entries format=format_name -print_format default=nw=1:nk=1 -v 0 "$@"
76 }
77
78 ffmpeg(){
79     dec_opts="-threads $threads -thread_type $thread_type"
80     ffmpeg_args="-nostats -cpuflags $cpuflags"
81     for arg in $@; do
82         [ x${arg} = x-i ] && ffmpeg_args="${ffmpeg_args} ${dec_opts}"
83         ffmpeg_args="${ffmpeg_args} ${arg}"
84     done
85     run ffmpeg ${ffmpeg_args}
86 }
87
88 framecrc(){
89     ffmpeg "$@" -f framecrc -
90 }
91
92 framemd5(){
93     ffmpeg "$@" -f framemd5 -
94 }
95
96 crc(){
97     ffmpeg "$@" -f crc -
98 }
99
100 md5(){
101     ffmpeg "$@" md5:
102 }
103
104 pcm(){
105     ffmpeg "$@" -vn -f s16le -
106 }
107
108 enc_dec_pcm(){
109     out_fmt=$1
110     dec_fmt=$2
111     pcm_fmt=$3
112     src_file=$(target_path $4)
113     shift 4
114     encfile="${outdir}/${test}.${out_fmt}"
115     cleanfiles=$encfile
116     encfile=$(target_path ${encfile})
117     ffmpeg -i $src_file "$@" -f $out_fmt -y ${encfile} || return
118     ffmpeg -flags +bitexact -i ${encfile} -c:a pcm_${pcm_fmt} -f ${dec_fmt} -
119 }
120
121 FLAGS="-flags +bitexact -sws_flags +accurate_rnd+bitexact"
122 DEC_OPTS="-threads $threads -idct simple $FLAGS"
123 ENC_OPTS="-threads 1        -idct simple -dct fastint"
124
125 enc_dec(){
126     src_fmt=$1
127     srcfile=$2
128     enc_fmt=$3
129     enc_opt=$4
130     dec_fmt=$5
131     dec_opt=$6
132     encfile="${outdir}/${test}.${enc_fmt}"
133     decfile="${outdir}/${test}.out.${dec_fmt}"
134     cleanfiles="$cleanfiles $decfile"
135     test "$7" = -keep || cleanfiles="$cleanfiles $encfile"
136     tsrcfile=$(target_path $srcfile)
137     tencfile=$(target_path $encfile)
138     tdecfile=$(target_path $decfile)
139     ffmpeg -f $src_fmt $DEC_OPTS -i $tsrcfile $ENC_OPTS $enc_opt $FLAGS \
140         -f $enc_fmt -y $tencfile || return
141     do_md5sum $encfile
142     echo $(wc -c $encfile)
143     ffmpeg $8 $DEC_OPTS -i $tencfile $ENC_OPTS $dec_opt $FLAGS \
144         -f $dec_fmt -y $tdecfile || return
145     do_md5sum $decfile
146     tests/tiny_psnr $srcfile $decfile $cmp_unit $cmp_shift
147 }
148
149 regtest(){
150     t="${test#$2-}"
151     ref=${base}/ref/$2/$t
152     ${base}/${1}-regression.sh $t $2 $3 "$target_exec" "$target_path" "$threads" "$thread_type" "$cpuflags" "$samples"
153 }
154
155 lavffatetest(){
156     regtest lavf lavf-fate tests/vsynth1
157 }
158
159 lavftest(){
160     regtest lavf lavf tests/vsynth1
161 }
162
163 #FIXME should be removed
164 lavfitest(){
165     cleanfiles="tests/data/lavfi/${test#lavfi-}.nut"
166     regtest lavfi lavfi tests/vsynth1
167 }
168
169 video_filter(){
170     filters=$1
171     shift
172     label=${test#filter-}
173     raw_src="${target_path}/tests/vsynth1/%02d.pgm"
174     printf '%-20s' $label
175     ffmpeg $DEC_OPTS -f image2 -vcodec pgmyuv -i $raw_src \
176         $FLAGS $ENC_OPTS -vf "$filters" -vcodec rawvideo $* -f nut md5:
177 }
178
179 pixdesc(){
180     pix_fmts="$(ffmpeg -pix_fmts list 2>/dev/null | awk 'NR > 8 && /^IO/ { print $2 }' | sort)"
181     for pix_fmt in $pix_fmts; do
182         test=$pix_fmt
183         video_filter "format=$pix_fmt,pixdesctest" -pix_fmt $pix_fmt
184     done
185 }
186
187 pixfmts(){
188     filter=${test#filter-pixfmts-}
189     filter_args=$1
190
191     showfiltfmts="$target_exec $target_path/libavfilter/filtfmts-test"
192     exclude_fmts=${outfile}${filter}_exclude_fmts
193     out_fmts=${outfile}${filter}_out_fmts
194
195     # exclude pixel formats which are not supported as input
196     ffmpeg -pix_fmts list 2>/dev/null | awk 'NR > 8 && /^\..\./ { print $2 }' | sort >$exclude_fmts
197     $showfiltfmts scale | awk -F '[ \r:]' '/^OUTPUT/{ print $5 }' | sort | comm -23 - $exclude_fmts >$out_fmts
198
199     pix_fmts=$($showfiltfmts $filter | awk -F '[ \r:]' '/^INPUT/{ print $5 }' | sort | comm -12 - $out_fmts)
200     for pix_fmt in $pix_fmts; do
201         test=$pix_fmt
202         video_filter "format=$pix_fmt,$filter=$filter_args" -pix_fmt $pix_fmt
203     done
204
205     rm $exclude_fmts $out_fmts
206 }
207
208 mkdir -p "$outdir"
209
210 # Disable globbing: command arguments may contain globbing characters and
211 # must be kept verbatim
212 set -f
213
214 exec 3>&2
215 eval $command >"$outfile" 2>$errfile
216 err=$?
217
218 if [ $err -gt 128 ]; then
219     sig=$(kill -l $err 2>/dev/null)
220     test "${sig}" = "${sig%[!A-Za-z]*}" || unset sig
221 fi
222
223 if test -e "$ref" || test $cmp = "oneline" ; then
224     case $cmp in
225         diff)   diff -u -b "$ref" "$outfile"            >$cmpfile ;;
226         oneoff) oneoff     "$ref" "$outfile"            >$cmpfile ;;
227         stddev) stddev     "$ref" "$outfile"            >$cmpfile ;;
228         oneline)oneline    "$ref" "$outfile"            >$cmpfile ;;
229         null)   cat               "$outfile"            >$cmpfile ;;
230     esac
231     cmperr=$?
232     test $err = 0 && err=$cmperr
233     test $err = 0 || cat $cmpfile
234 else
235     echo "reference file '$ref' not found"
236     err=1
237 fi
238
239 echo "${test}:${sig:-$err}:$($base64 <$cmpfile):$($base64 <$errfile)" >$repfile
240
241 if test $err != 0 && test $gen != "no" ; then
242     echo "GEN     $ref"
243     cp -f "$outfile" "$ref"
244     err=$?
245 fi
246
247 if test $err = 0; then
248     rm -f $outfile $errfile $cmpfile $cleanfiles
249 elif test $gen = "no"; then
250     echo "Test $test failed. Look at $errfile for details."
251 else
252     echo "Updating reference failed, possibly no output file was generated."
253 fi
254 exit $err